VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4110
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6900
   LinkTopic       =   "Form1"
   ScaleHeight     =   4110
   ScaleWidth      =   6900
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdLoadFiles 
      Caption         =   "Load Files"
      Height          =   495
      Left            =   2760
      TabIndex        =   3
      Top             =   3600
      Width           =   1335
   End
   Begin VB.TextBox txtNumFiles 
      Height          =   285
      Left            =   0
      TabIndex        =   2
      Text            =   "1000"
      Top             =   3720
      Width           =   735
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "Browse"
      Height          =   375
      Left            =   6000
      TabIndex        =   6
      Top             =   3120
      Width           =   855
   End
   Begin VB.TextBox txtDestination 
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Top             =   3120
      Width           =   5895
   End
   Begin VB.CommandButton cmdRemove 
      Caption         =   "Remove"
      Height          =   375
      Left            =   6000
      TabIndex        =   5
      Top             =   720
      Width           =   855
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   375
      Left            =   6000
      TabIndex        =   4
      Top             =   240
      Width           =   855
   End
   Begin VB.ListBox lstSources 
      Height          =   2595
      Left            =   0
      MultiSelect     =   2  'Extended
      TabIndex        =   0
      Top             =   240
      Width           =   5895
   End
   Begin VB.Label lblNumFiles 
      Caption         =   "# Files"
      Height          =   255
      Left            =   0
      TabIndex        =   9
      Top             =   3480
      Width           =   735
   End
   Begin VB.Label lblDestination 
      Caption         =   "Destination"
      Height          =   255
      Left            =   0
      TabIndex        =   8
      Top             =   2880
      Width           =   2775
   End
   Begin VB.Label Label1 
      Caption         =   "Sources"
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   0
      Width           =   2775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub SaveSettings()
Dim i As Integer

    On Error Resume Next
    DeleteSetting App.ProductName
    On Error GoTo 0

    SaveSetting App.ProductName, "Settings", "DestinationDirectory", txtDestination.Text
    SaveSetting App.ProductName, "Settings", "NumFiles", txtNumFiles.Text

    For i = 0 To lstSources.ListCount - 1
        SaveSetting App.ProductName, "Settings", "Source" & Format$(i), lstSources.List(i)
        SaveSetting App.ProductName, "Settings", "Selected" & Format$(i), lstSources.Selected(i)
    Next i
End Sub
Private Sub LoadSettings()
Dim i As Integer
Dim txt As String

    txtDestination.Text = GetSetting(App.ProductName, _
        "Settings", "DestinationDirectory", CurDir)
    txtNumFiles.Text = GetSetting(App.ProductName, _
        "Settings", "NumFiles", "1")

    lstSources.Clear
    For i = 0 To 100
        txt = GetSetting(App.ProductName, "Settings", "Source" & Format$(i), "")
        If Len(txt) < 1 Then Exit For
        lstSources.AddItem txt
        lstSources.Selected(i) = CBool(GetSetting(App.ProductName, "Settings", "Selected" & Format$(i), "False"))
    Next i
End Sub

Private Sub cmdAdd_Click()
    dlgPickFolder.txtDir.Text = CurDir
    dlgPickFolder.Show vbModal
    If Len(dlgPickFolder.txtDir.Text) > 0 Then
        On Error Resume Next
        ChDir dlgPickFolder.txtDir.Text
        If Err.Number <> 0 Then
            MsgBox "Error moving to directory '" & _
                dlgPickFolder.txtDir.Text & "'", _
                vbExclamation Or vbOKOnly, _
                "Directory Error"
        Else
            lstSources.AddItem dlgPickFolder.txtDir.Text
        End If
        On Error GoTo 0
    End If
    Unload dlgPickFolder
End Sub

Private Sub cmdBrowse_Click()
Dim dir_name As String

    dir_name = BrowseForDirectory(Me.hwnd)
    If Len(dir_name) > 0 Then
        txtDestination.Text = dir_name
    End If
End Sub

Private Sub cmdLoadFiles_Click()
Dim directories As Collection
Dim file_names As Collection
Dim i As Integer
Dim num_files As Integer
Dim indexes() As Integer
Dim dest_dir As String
Dim files_to_copy As Integer
Dim files_copied As Integer
Dim from_name As String
Dim to_name As String

    ' Make a list of all of the files.
    Set directories = New Collection
    Set file_names = New Collection
    For i = 0 To lstSources.ListCount - 1
        If lstSources.Selected(i) Then
            ListFiles lstSources.List(i), directories, file_names
        End If
    Next i

    ' See how many files we found.
    num_files = file_names.Count
    If num_files < 1 Then
        MsgBox "No files found", vbExclamation Or vbOKOnly, "No Files"
        Exit Sub
    End If

    ' Make the indexes array.
    ReDim indexes(1 To num_files)
    For i = 1 To num_files
        indexes(i) = i
    Next i

    ' Randomize the indexes array.
    RandomizeArray indexes

    ' Grab the first files.
    files_to_copy = CInt(txtNumFiles.Text)
    If files_to_copy > num_files Then files_to_copy = num_files

    ' Start copying files.
    dest_dir = txtDestination.Text
    files_copied = 0
    On Error Resume Next
    For i = 1 To files_to_copy
        from_name = directories(indexes(i)) & "\" & file_names(indexes(i))
        to_name = dest_dir & "\" & file_names(indexes(i))
        FileCopy from_name, to_name
        If Err.Number <> 0 Then
            MsgBox "Error copying file '" & from_name & _
                "' to file '" & to_name & "'" & vbCrLf & _
                Err.Description, _
                vbExclamation Or vbOKOnly, _
                "Copy Error"
            Exit For
        End If
        files_copied = files_copied + 1
'        Debug.Print i & ": FileCopy """ & _
'            directories(indexes(i)) & "\" & file_names(indexes(i)) & """, """ & _
'            dest_dir & "\" & file_names(indexes(i)) & """"
    Next i
    On Error GoTo 0

    MsgBox "Copied " & files_copied & " files", _
        vbInformation Or vbOKOnly, "Done"
End Sub
Private Sub cmdRemove_Click()
Dim i As Integer

    If lstSources.ListCount < 1 Then
        MsgBox "No sources selected to delete", vbInformation Or vbOKOnly, "No Sources Selected"
    ElseIf MsgBox("Delete selected sources?", vbQuestion Or vbYesNo, "Delete Sources?") = vbYes Then
        For i = lstSources.ListCount - 1 To 0 Step -1
            If lstSources.Selected(i) Then
                lstSources.RemoveItem i
            End If
        Next i
    End If
End Sub

Private Sub Form_Load()
    Me.Caption = App.ProductName

    LoadSettings
End Sub
Private Sub Form_Resize()
Const GAP As Integer = 60
Dim wid As Single
Dim hgt As Single

    cmdAdd.Left = Me.ScaleWidth - cmdAdd.Width
    cmdRemove.Left = cmdAdd.Left
    cmdRemove.Left = cmdAdd.Left

    cmdLoadFiles.Move (Me.ScaleWidth - cmdLoadFiles.Width) / 2, Me.ScaleHeight - cmdLoadFiles.Height

    txtNumFiles.Top = Me.ScaleHeight - txtNumFiles.Height
    lblNumFiles.Top = txtNumFiles.Top - lblNumFiles.Height

    txtNumFiles.Top = Me.ScaleHeight - txtNumFiles.Height
    lblNumFiles.Top = txtNumFiles.Top - lblNumFiles.Height

    wid = cmdAdd.Left - GAP
    If wid < 120 Then wid = 120

    txtDestination.Move 0, lblNumFiles.Top - txtDestination.Height - GAP, wid
    lblDestination.Top = txtDestination.Top - lblDestination.Height
    cmdBrowse.Move Me.ScaleWidth - cmdBrowse.Width, txtDestination.Top

    hgt = lblDestination.Top - lstSources.Top - GAP
    If hgt < 120 Then hgt = 120
    lstSources.Move 0, lstSources.Top, wid, hgt
End Sub
Private Sub Form_Unload(Cancel As Integer)
    SaveSettings
End Sub

Private Sub lstSources_KeyPress(KeyAscii As Integer)
Const ASC_CTRL_A As Integer = 1
Dim i As Integer

    If KeyAscii = ASC_CTRL_A Then
        For i = 0 To lstSources.ListCount - 1
            lstSources.Selected(i) = True
        Next i
    End If
End Sub


